TSEULER_PANEL_DESCRIPTORS = {'logo_description':'''<b>T</b>ime <b>S</b>eries : <b>M</b>ini <b>A</b>nalysis <b>D</b>ashboard.
<br></br>A mini-dashboard for Time Series Analysis ->
Uni-Variate, Bi-Variate & Multi-Variate on just click of a button!'''}


TS_UV_PLOTS = ['Line Plot : Overtime Analysis',
                'Area Chart : Overtime Analysis',
                'Box Plot : Variation Analysis',
                'Ridge Plot : Distribution Analysis',
                'Seasonal Plot : Variation Analysis',
                'Histogram : Distribution Analysis',
                'ACF Plot : Relation Analysis',
                'PACF Plot : Relation Analysis',
                'Q-Q Plot : Distribution Analysis',
                'Moving Average : Series Smoothing',
                'Simple Exponential : Series Smoothing',
                'Fourier : Series Smoothing']
                
TS_BV_PLOTS = ['Line Plot : Overtime Analysis',
               'Area Plot : Overtime Analysis',
               'Violin Plot : Distribution Analysis',
               'Scatter Plot : Relation Analysis',
               'Reg Plot : Relation Analysis',
               'KDE Plot : Relation Analysis',
               'Joint Plot : Relation Analysis']

TS_TV_PLOTS = ['Linked Scatter Plot : Relation Analysis']

TSMAD_CONFIGS = {'plotting.default_engine' : 'Interactive',
                 'plotting.uv.ma_window' : 0.01,
                 'plotting.uv.exp_span' : 0.01,
                 'plotting.uv.fcomp_factor' : 0.01,
                 'stat.corr_type':'pearson'}


TS_FREQUENCIES = [r'S', r'T', r'H',
                  r'\d+S$', r'\d+T$', r'\d+H$',
                  
                  r'D', r'B',
                  r'\d+D$', r'\d+B$',
                  
                  r'W-MON',r'W-TUE',r'W-WED',r'W-THU',r'W-FRI',r'W-SAT',r'W-SUN',
                  r'\d+W-MON$',r'\d+W-TUE$',r'\d+W-WED$',r'\d+W-THU$',r'\d+W-FRI$',r'\d+W-SAT$',r'\d+W-SUN$',
                 
                  r'MS', r'M',
                  r'\d+MS$', r'\d+M$',
                 
                  r'QS-JAN', r'QS-FEB', r'QS-MAR', r'QS-APR', r'QS-MAY', r'QS-JUN', r'QS-JUL', r'QS-AUG', r'QS-SEP', r'QS-OCT', r'QS-NOV', r'QS-DEC',
                  r'\d+QS-JAN$', r'\d+QS-FEB$', r'\d+QS-MAR$', r'\d+QS-APR$', r'\d+QS-MAY$', r'\d+QS-JUN$', r'\d+QS-JUL$', r'\d+QS-AUG$', r'\d+QS-SEP$', r'\d+QS-OCT$', r'\d+QS-NOV$', r'\d+QS-DEC$',
                  
                  r'Q-JAN', r'Q-FEB', r'Q-MAR', r'Q-APR', r'Q-MAY', r'Q-JUN', r'Q-JUL', r'Q-AUG', r'Q-SEP', r'Q-OCT', r'Q-NOV', r'Q-DEC',
                  r'\d+Q-JAN$', r'\d+Q-FEB$', r'\d+Q-MAR$', r'\d+Q-APR$', r'\d+Q-MAY$', r'\d+Q-JUN$', r'\d+Q-JUL$', r'\d+Q-AUG$', r'\d+Q-SEP$', r'\d+Q-OCT$', r'\d+Q-NOV$', r'\d+Q-DEC$',
                  
                  r'AS-JAN', r'AS-FEB', r'AS-MAR', r'AS-APR', r'AS-MAY', r'AS-JUN', r'AS-JUL', r'AS-AUG', r'AS-SEP', r'AS-OCT', r'AS-NOV', r'AS-DEC',
                  r'\d+AS-JAN$', r'\d+AS-FEB$', r'\d+AS-MAR$', r'\d+AS-APR$', r'\d+AS-MAY$', r'\d+AS-JUN$', r'\d+AS-JUL$', r'\d+AS-AUG$', r'\d+AS-SEP$', r'\d+AS-OCT$', r'\d+AS-NOV$', r'\d+AS-DEC$',
                  
                  r'A-JAN', r'A-FEB', r'A-MAR', r'A-APR', r'A-MAY', r'A-JUN', r'A-JUL', r'A-AUG', r'A-SEP', r'A-OCT', r'A-NOV', r'A-DEC',
                  r'\d+A-JAN$', r'\d+A-FEB$', r'\d+A-MAR$', r'\d+A-APR$', r'\d+A-MAY$', r'\d+A-JUN$', r'\d+A-JUL$', r'\d+A-AUG$', r'\d+A-SEP$', r'\d+A-OCT$', r'\d+A-NOV$', r'\d+A-DEC$']

TS_FREQUENCIES_DESC = {'S': 'Seconds',
                       'T': 'Minutely',
                       'H': 'Hourly',
                       'D': 'Daily',
                       'B': 'Buisness Days',
                       'W-SUN': 'Weekly(Sun)',
                       'W-MON': 'Weekly(Mon)',
                       'W-TUE': 'Weekly(Tue)',
                       'W-WED': 'Weekly(Wed)',
                       'W-THU': 'Weekly(Thu)',
                       'W-FRI': 'Weekly(Fri)',
                       'W-SAT': 'Weekly(Sat)',
                       'MS': 'Month Start',
                       'M': 'Month End',
                       'QS-JAN': 'Quarter Start(Jan)',
                       'QS-FEB': 'Quarter Start(Feb)',
                       'QS-MAR': 'Quarter Start(Mar)',
                       'QS-APR': 'Quarter Start(Apr)',
                       'QS-MAY': 'Quarter Start(May)',
                       'QS-JUN': 'Quarter Start(Jun)',
                       'QS-JUL': 'Quarter Start(Jul)',
                       'QS-AUG': 'Quarter Start(Aug)',
                       'QS-SEP': 'Quarter Start(Sep)',
                       'QS-OCT': 'Quarter Start(Oct)',
                       'QS-NOV': 'Quarter Start(Nov)',
                       'QS-DEC': 'Quarter Start(Dec)',
                       'Q-JAN': 'Quarter End(Jan)',
                       'Q-FEB': 'Quarter End(Feb)',
                       'Q-MAR': 'Quarter End(Mar)',
                       'Q-APR': 'Quarter End(Apr)',
                       'Q-MAY': 'Quarter End(May)',
                       'Q-JUN': 'Quarter End(Jun)',
                       'Q-JUL': 'Quarter End(Jul)',
                       'Q-AUG': 'Quarter End(Aug)',
                       'Q-SEP': 'Quarter End(Sep)',
                       'Q-OCT': 'Quarter End(Oct)',
                       'Q-NOV': 'Quarter End(Nov)',
                       'Q-DEC': 'Quarter End(Dec)',
                       'AS-JAN': 'Year Start(Jan)',
                       'AS-FEB': 'Year Start(Feb)',
                       'AS-MAR': 'Year Start(Mar)',
                       'AS-APR': 'Year Start(Apr)',
                       'AS-MAY': 'Year Start(May)',
                       'AS-JUN': 'Year Start(Jun)',
                       'AS-JUL': 'Year Start(Jul)',
                       'AS-AUG': 'Year Start(Aug)',
                       'AS-SEP': 'Year Start(Sep)',
                       'AS-OCT': 'Year Start(Oct)',
                       'AS-NOV': 'Year Start(Nov)',
                       'AS-DEC': 'Year Start(Dec)',
                       'A-JAN': 'Year End(Jan)',
                       'A-FEB': 'Year End(Feb)',
                       'A-MAR': 'Year End(Mar)',
                       'A-APR': 'Year End(Apr)',
                       'A-MAY': 'Year End(May)',
                       'A-JUN': 'Year End(Jun)',
                       'A-JUL': 'Year End(Jul)',
                       'A-AUG': 'Year End(Aug)',
                       'A-SEP': 'Year End(Sep)',
                       'A-OCT': 'Year End(Oct)',
                       'A-NOV': 'Year End(Nov)',
                       'A-DEC': 'Year End(Dec)'}

TS_FORMATS = ['%Y-%m-%d', '%Y-%m-%d HH:MM:SS']

TS_FREQ_MAP =  {'S' : ['T', 'D','W-SUN', 'W-MON', 'W-TUE', 'W-WED', 'W-THU', 'W-FRI', 'W-SAT',
                        'MS', 'M', 'QS-JAN', 'QS-FEB', 'QS-MAR', 'QS-APR', 'QS-MAY',
                        'QS-JUN', 'QS-JUL', 'QS-AUG', 'QS-SEP', 'QS-OCT', 'QS-NOV',
                        'QS-DEC', 'Q-JAN', 'Q-FEB', 'Q-MAR', 'Q-APR', 'Q-MAY', 'Q-JUN',
                        'Q-JUL', 'Q-AUG', 'Q-SEP', 'Q-OCT', 'Q-NOV', 'Q-DEC', 'AS-JAN',
                        'AS-FEB', 'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN', 'AS-JUL',
                        'AS-AUG', 'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC', 'A-JAN', 'A-FEB',
                        'A-MAR', 'A-APR', 'A-MAY', 'A-JUN', 'A-JUL', 'A-AUG', 'A-SEP',
                        'A-OCT', 'A-NOV', 'A-DEC'],
                'T' : ['H', 'D','W-SUN', 'W-MON', 'W-TUE', 'W-WED', 'W-THU', 'W-FRI', 'W-SAT',
                        'MS', 'M', 'QS-JAN', 'QS-FEB', 'QS-MAR', 'QS-APR', 'QS-MAY',
                        'QS-JUN', 'QS-JUL', 'QS-AUG', 'QS-SEP', 'QS-OCT', 'QS-NOV',
                        'QS-DEC', 'Q-JAN', 'Q-FEB', 'Q-MAR', 'Q-APR', 'Q-MAY', 'Q-JUN',
                        'Q-JUL', 'Q-AUG', 'Q-SEP', 'Q-OCT', 'Q-NOV', 'Q-DEC', 'AS-JAN',
                        'AS-FEB', 'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN', 'AS-JUL',
                        'AS-AUG', 'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC', 'A-JAN', 'A-FEB',
                        'A-MAR', 'A-APR', 'A-MAY', 'A-JUN', 'A-JUL', 'A-AUG', 'A-SEP',
                        'A-OCT', 'A-NOV', 'A-DEC'],
                'H' : ['D','W-SUN', 'W-MON', 'W-TUE', 'W-WED', 'W-THU', 'W-FRI', 'W-SAT',
                        'MS', 'M', 'QS-JAN', 'QS-FEB', 'QS-MAR', 'QS-APR', 'QS-MAY',
                        'QS-JUN', 'QS-JUL', 'QS-AUG', 'QS-SEP', 'QS-OCT', 'QS-NOV',
                        'QS-DEC', 'Q-JAN', 'Q-FEB', 'Q-MAR', 'Q-APR', 'Q-MAY', 'Q-JUN',
                        'Q-JUL', 'Q-AUG', 'Q-SEP', 'Q-OCT', 'Q-NOV', 'Q-DEC', 'AS-JAN',
                        'AS-FEB', 'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN', 'AS-JUL',
                        'AS-AUG', 'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC', 'A-JAN', 'A-FEB',
                        'A-MAR', 'A-APR', 'A-MAY', 'A-JUN', 'A-JUL', 'A-AUG', 'A-SEP',
                        'A-OCT', 'A-NOV', 'A-DEC'],

                'D' : ['W-SUN', 'W-MON', 'W-TUE', 'W-WED', 'W-THU', 'W-FRI', 'W-SAT',
                        'MS', 'M', 'QS-JAN', 'QS-FEB', 'QS-MAR', 'QS-APR', 'QS-MAY',
                        'QS-JUN', 'QS-JUL', 'QS-AUG', 'QS-SEP', 'QS-OCT', 'QS-NOV',
                        'QS-DEC', 'Q-JAN', 'Q-FEB', 'Q-MAR', 'Q-APR', 'Q-MAY', 'Q-JUN',
                        'Q-JUL', 'Q-AUG', 'Q-SEP', 'Q-OCT', 'Q-NOV', 'Q-DEC', 'AS-JAN',
                        'AS-FEB', 'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN', 'AS-JUL',
                        'AS-AUG', 'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC', 'A-JAN', 'A-FEB',
                        'A-MAR', 'A-APR', 'A-MAY', 'A-JUN', 'A-JUL', 'A-AUG', 'A-SEP',
                        'A-OCT', 'A-NOV', 'A-DEC'],
                'B' : ['W-SUN', 'W-MON', 'W-TUE', 'W-WED', 'W-THU', 'W-FRI', 'W-SAT',
                        'MS', 'M', 'QS-JAN', 'QS-FEB', 'QS-MAR', 'QS-APR', 'QS-MAY',
                        'QS-JUN', 'QS-JUL', 'QS-AUG', 'QS-SEP', 'QS-OCT', 'QS-NOV',
                        'QS-DEC', 'Q-JAN', 'Q-FEB', 'Q-MAR', 'Q-APR', 'Q-MAY', 'Q-JUN',
                        'Q-JUL', 'Q-AUG', 'Q-SEP', 'Q-OCT', 'Q-NOV', 'Q-DEC', 'AS-JAN',
                        'AS-FEB', 'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN', 'AS-JUL',
                        'AS-AUG', 'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC', 'A-JAN', 'A-FEB',
                        'A-MAR', 'A-APR', 'A-MAY', 'A-JUN', 'A-JUL', 'A-AUG', 'A-SEP',
                        'A-OCT', 'A-NOV', 'A-DEC'],
                'W' : ['MS', 'M', 'QS-JAN', 'QS-FEB', 'QS-MAR', 'QS-APR', 'QS-MAY',
                        'QS-JUN', 'QS-JUL', 'QS-AUG', 'QS-SEP', 'QS-OCT', 'QS-NOV',
                        'QS-DEC', 'Q-JAN', 'Q-FEB', 'Q-MAR', 'Q-APR', 'Q-MAY', 'Q-JUN',
                        'Q-JUL', 'Q-AUG', 'Q-SEP', 'Q-OCT', 'Q-NOV', 'Q-DEC', 'AS-JAN',
                        'AS-FEB', 'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN', 'AS-JUL',
                        'AS-AUG', 'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC', 'A-JAN', 'A-FEB',
                        'A-MAR', 'A-APR', 'A-MAY', 'A-JUN', 'A-JUL', 'A-AUG', 'A-SEP',
                        'A-OCT', 'A-NOV', 'A-DEC'],
                'MS' : ['QS-JAN', 'QS-FEB', 'QS-MAR', 'QS-APR', 'QS-MAY', 'QS-JUN',
                        'QS-JUL', 'QS-AUG', 'QS-SEP', 'QS-OCT', 'QS-NOV', 'QS-DEC',
                        'Q-JAN', 'Q-FEB', 'Q-MAR', 'Q-APR', 'Q-MAY', 'Q-JUN', 'Q-JUL',
                        'Q-AUG', 'Q-SEP', 'Q-OCT', 'Q-NOV', 'Q-DEC', 'AS-JAN', 'AS-FEB',
                        'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN', 'AS-JUL', 'AS-AUG',
                        'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC', 'A-JAN', 'A-FEB', 'A-MAR',
                        'A-APR', 'A-MAY', 'A-JUN', 'A-JUL', 'A-AUG', 'A-SEP', 'A-OCT',
                        'A-NOV', 'A-DEC'],
                'M' : ['QS-JAN', 'QS-FEB', 'QS-MAR', 'QS-APR', 'QS-MAY', 'QS-JUN',
                        'QS-JUL', 'QS-AUG', 'QS-SEP', 'QS-OCT', 'QS-NOV', 'QS-DEC',
                        'Q-JAN', 'Q-FEB', 'Q-MAR', 'Q-APR', 'Q-MAY', 'Q-JUN', 'Q-JUL',
                        'Q-AUG', 'Q-SEP', 'Q-OCT', 'Q-NOV', 'Q-DEC', 'AS-JAN', 'AS-FEB',
                        'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN', 'AS-JUL', 'AS-AUG',
                        'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC', 'A-JAN', 'A-FEB', 'A-MAR',
                        'A-APR', 'A-MAY', 'A-JUN', 'A-JUL', 'A-AUG', 'A-SEP', 'A-OCT',
                        'A-NOV', 'A-DEC'],
                'QS' : ['AS-JAN', 'AS-FEB', 'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN',
                        'AS-JUL', 'AS-AUG', 'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC',
                        'A-JAN', 'A-FEB', 'A-MAR', 'A-APR', 'A-MAY', 'A-JUN', 'A-JUL',
                        'A-AUG', 'A-SEP', 'A-OCT', 'A-NOV', 'A-DEC'],
                'Q' : ['AS-JAN', 'AS-FEB', 'AS-MAR', 'AS-APR', 'AS-MAY', 'AS-JUN',
                        'AS-JUL', 'AS-AUG', 'AS-SEP', 'AS-OCT', 'AS-NOV', 'AS-DEC',
                        'A-JAN', 'A-FEB', 'A-MAR', 'A-APR', 'A-MAY', 'A-JUN', 'A-JUL',
                        'A-AUG', 'A-SEP', 'A-OCT', 'A-NOV', 'A-DEC'],
                'AS' : [],
                'A' : []}

AVAILABLE_AGG_FUNC = ['sum', 'mean', 'median',  'std', 'var',
                      'last', 'first', 'min', 'max']


